(*$M 2048,0,0*)
(*S-*)
program Ascii_Table;

uses crt,dos,tsr;
(* Unit TSR pubblicata su 
   MCmicrocomputer numeri 
   Gennaio 1990 e seguenti *)

type hextype=string[2];

const sp_char:array[0..31] of string[3]=
      ('NUL','SOH','STX','ETX','EOT','ENQ','ACK','BEL','BS ','HT ','LF ',
       'VT ','FF ','CR ','SO ','SI ','DLE','DC1','DC2','DC3','DC4','NAK',
       'SYN','ETB','CAN','EN ','SUB','ESC','FS ','GS ','RS ','US ');

var pp:shortint;
    base:word;
    pos:shortint;
    reg:registers;
    tmp:pointer;

procedure setupwin;
var n:shortint;
begin
  gotoxy(1,1); textcolor(yellow); textbackground(blue);
  writeln('͵ Tabella Ascii ͻ');
  writeln('                    ');
  for n:=1 to 16 do writeln('                    ');
  writeln('                    ');
  writeln('ͼ');
end;

function hex(n:integer):hextype;
var p:shortint;
    tmp:hextype;
begin
  p:=n div 16;
  if (P<10) then tmp:=chr(p+48) else tmp:=chr(p+55);
  p:=n mod 16;
  if (p<10) then hex:=concat(tmp,chr(p+48)) else hex:=concat(tmp,chr(p+55));
end;

procedure writeasc(n,mult:integer);
begin
  gotoxy(3,3+(n mod mult));
  case n of
     7: begin write(' '); mem[base:$05a4]:=7; end;
     8: begin write(' '); mem[base:$0644]:=8; end;
    10: begin write(' '); mem[base:$0784]:=10; end;
    13: begin write(' '); mem[base:$0964]:=13; end;
    else write(chr(n));
  end;
  write(' ',hex(n),' ');
  if (n<100) then write('0');
  if (n<10) then write('0');
  write(n);
  if mult=32 then begin
    write('  ',chr(n+16),' ',hex(n+16),' ');
    if (n+16<100) then write('0');
    if (n+16<10) then write('0');
    write(n+16);
  end else write('    ^',chr(n+64),' ',sp_char[n],'  ');
end;

procedure show(page:shortint) ;
var n:integer;
    asc:boolean;
begin
  if page<2 then begin
    gotoxy(12,2);
    write(' ');
    gotoxy(12,19);
    write(' ');
    for n:=page*16 to 15+(page*16) do writeasc(n,16);
  end else begin
    gotoxy(12,2);
    write('');
    gotoxy(12,19);
    write('');
    for n:=(page-1)*32 to 15+((page-1)*32) do writeasc(n,32);
  end;
  reg.ah:=$02; reg.bh:=$00; reg.dh:=$25;
  intr(16,reg);
end;

procedure tasti;
var ch,sc:char;
begin
  while (true) do begin
    ch:=readkey;
    if CtrlBreak then begin
      ch := #27;
      CtrlBreak := FALSE;
    end;
    case ch of
     #27: exit;
     #03: begin
            ch := #27;
            exit;
          end;
     #00: begin
            sc:=readkey;
            if CtrlBreak then begin
              sc := #27;
              CtrlBreak := FALSE;
            end;
              case sc of
              #03: begin
                     sc := #27;
                     exit;
                   end;
              #81,#80,#77: begin
                             inc(Pp);
                             if (Pp=9) then Pp:=00;
                             Show(Pp);
                           end;
              #73,#72,#75: begin
                             dec(Pp);
                             if (Pp<0) then Pp:=8;
                             Show(Pp);
                           end;
              end;
            end;
    end;
  end;
end;

{$f+}

procedure tabellaascii;
begin
  setupwin;
  show(Pp);
  tasti;
end;

{$f-}

begin
  Pp:=0;
  if ((mem[$0000:$0410] and $30)=$30) then base:=$b000 else base:=$b800;
  installa('ASCIITBL',tabellaascii,$f1,0,6);
end.

